<?php
// Класс работы с БД
// Этот файл может быть изменён разработчиком

namespace BotKit\Common;

class Database {
    private static $db;
    private $connection;
    
    private function __construct($dsn, $user, $password) {
        // https://mariadb.com/resources/blog/developer-quickstart-php-data-objects-and-mariadb/
        $options = [
            \PDO::ATTR_EMULATE_PREPARES   => false,
            \PDO::ATTR_ERRMODE            => \PDO::ERRMODE_EXCEPTION,
            \PDO::ATTR_DEFAULT_FETCH_MODE => \PDO::FETCH_ASSOC,
        ];
        $this->connection = new \PDO($dsn, $user, $password);
    }

    // Инициализирует БД
    public static function init($host=null,$db_name=null,$user=null,$password=null): void {

        $host       = $host     ? $host     : $_ENV['db_host'];
        $db_name    = $db_name  ? $db_name  : $_ENV['db_name'];
        $user       = $user     ? $user     : $_ENV['db_user'];
        $password   = $password ? $password : $_ENV['db_password'];

        if (self::$db == null) {
            self::$db = new Database(
                "mysql:host=".$host.";dbname=".$db_name.";charset=utf8mb4",
                $user,
                $password
            );
        }
    }

    public static function getConnection() {
        if (self::$db == null) {
            self::init();
        }
        return self::$db->connection;
    }
}
