<?php
// Класс работы с моделями
// Только для наследования

namespace BotKit\Models;

use BotKit\Common\Database;

class Model {
    protected static $allowed_columns;

    protected static function allowedColumnsSQL() {
        return implode(',', static::$allowed_columns);
    }

    // Возвращает все записи из таблицы
    public static function all() {
        $db = Database::getConnection();
        return $db->query("SELECT ".static::allowedColumnsSQL()." FROM ".static::$table_name);
    }

    // Поиск по ID
    public static function find($id) {
        $db = Database::getConnection();
        $stm = $db->prepare("SELECT ".static::allowedColumnsSQL()." FROM ".static::$table_name. " WHERE id=:id");
        $stm->bindValue(':id', $id);
        $stm->execute();
        return $stm->fetch();
    }

    // Возвращает записи по условиям
    // Все условия должны быть истины, т. к. для построения запроса используется 'AND'
    public static function where($conditions) {
        $db = Database::getConnection();

        // Построение текста условий
        $conditions_sql = '';
        $first_condition = true;
        foreach ($conditions as $condition) {
            if ($first_condition == false) {
                $conditions_sql .= " AND ";
            }
            $conditions_sql .= $condition[0].$condition[1].':'.$condition[0];
            $first_condition = false;
        }

        $stm = $db->prepare(
            "SELECT ".static::allowedColumnsSQL()." FROM ".static::$table_name." WHERE ".$conditions_sql
        );
        foreach ($conditions as $condition) {
            $stm->bindValue(":".$condition[0], $condition[2]);
        }
        $stm->execute();
        return $stm->fetchAll();
    }
}